
# return a seed from 0..2^40-1.  python "random" module wants 0..2^44+

# algorithm:
# 1) we try /dev/random first.
# 2) failing that, we try /dev/urandom
# 3) failing that, we try prngd on localhost:708
# 4) failing that, we use time + pid



# Example usage:

#pinch2-strombrg> python
#Python 2.1 (#1, Oct  5 2001, 17:44:14) 
#[GCC 2.95.2 19991024 (release)] on linux2
#Type "copyright", "credits" or "license" for more information.
#>>> import seed
#>>> import random
#>>> g=random.Random(seed.seed())
#>>> g.random()
#0.61267955911560534
#>>> g.random()
#0.62195548504378495



def seed():
	file_opened=1
	try:
		file = open('/dev/random','r')
	except:
		file_opened=0
	if not file_opened:
		file_opened=1
		try:
			file = open('/dev/urandom','r')
		except:
			file_opened=0
	
	if file_opened:
		seed = 0L
		for i in range(0,5):
			ch=file.read(1)
			seed = seed*256 + ord(ch)
		file.close()
	else:
		import socket
		sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
		sock_opened=1
		try:
			sock.connect(('localhost',708))
		except:
			sock_opened=0
		if sock_opened:
			# 2 means read blocking, 5 means gimme 5 bytes
			sock.send('\002\005')
			seed = 0L
			for i in range(0,5):
				ch=sock.recv(1)
				seed = seed*256 + ord(ch)
			sock.close()
		else:
			import time
			import os
			seed = (long(time.time()) + os.getpid()) % pow(2L,32)
	
	return seed

